attribute vec3 at_midBlock;
attribute vec4 at_tangent;
attribute vec4 mc_Entity;
attribute vec4 mc_midTexCoord;

flat out int vertBlockID;

out vec2 vertCoord;
out vec2 vertMidCoord;

flat out vec3 vertNormal;

out vec3 vertTint;
out vec3 centerDist;

flat out vec4 vertTangent;

#include "/lib/mat/idTable.glsl"

/* VOXEL DATA */
flat out int canBeVoxelized;
flat out ivec2 vertObjectID;

void main() {
    gl_Position     = gl_Vertex;

    vertCoord       = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    vertMidCoord    = (gl_TextureMatrix[0] * mc_midTexCoord).xy;

    vertNormal      = gl_Normal;
    vertTangent     = at_tangent;

    vertTint        = gl_Color.rgb;

    int mcEntity    = int(mc_Entity.x);

    centerDist      = at_midBlock / 64.0;

    canBeVoxelized = 1;
    if (mcEntity == 0
     || mcEntity == 1010
     || mcEntity == 10022
     || mcEntity == 10023
     || mcEntity == 10024
     || mcEntity == 10025
     || mcEntity == 1040) canBeVoxelized = 0;

    vertObjectID    = ivec2(remapShapeID(mcEntity), remapEmissionID(mcEntity));

    vertBlockID     = 0;
    if (mcEntity == 1040) vertBlockID = 102;
}