#version 400 compatibility

/*
====================================================================================================

    Copyright (C) 2021 RRe36

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://rre36.com/copyright-license

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/

#include "/lib/head.glsl"

out vec2 coord;

flat out vec3 airIlluminance;
flat out mat2x3 airIllumMod;

uniform float eyeAltitude;

uniform float wetness;

uniform vec2 viewSize;

uniform vec3 sunDir;
uniform vec3 moonDir;

uniform vec4 daytime;

#include "/lib/atmos/phase.glsl"
#include "/lib/atmos/air/atmosphere.glsl"

void main() {
    gl_Position = vec4(gl_Vertex.xy * 2.0 - 1.0, 0.0, 1.0);
    coord = gl_MultiTexCoord0.xy;

    airIlluminance  = atmosphericScattering(vec3(0.0, 1.0, 0.0), mat2x3(sunDir, moonDir), vec3(0.0), mat2x3(0.0));

    vec3 airEyePos  = vec3(0.0, planetRad + eyeAltitude, 0.0);
    airIllumMod     = mat2x3(getAirTransmittance(airEyePos, sunDir, 6)  * sunIllum  / sunIllum.r, 
                             getAirTransmittance(airEyePos, moonDir, 6) * moonIllum / moonIllum.b);
}